Subject: Re: About pku-1.1 update

From: Zheng Gengbing <[email-masked]>
Date: Thu, 28 Mar 1996 09:17:43 +0800 (EAT)

On Wed, 27 Mar 1996, Guansong Zhang wrote:

> Hi,
> 
> I send this letter hours ago. Now, after getting a new pku-1.1, I can make the
> following update:
> 
> The new 1.1 can be successfully made on RS/6000(AIX 3.2.5) here. Compared with
> the old 1.1, warning messages are reduced dramatically. (hpfcc can be made
> without any changing).

  I had  added two prototype definition files '/src/include/decl.h' and 
'/src/hpf2dep/exec_part.h'  , and modified all files to include these head
files in this new version . This reduced a lot of warings.

> 
> But the results of testing in hpfcc/Testsuite remains the same. Except one more
> cause memory fault, b8
> 
> This time I don't use gcc to test the result. I am afraid that our cc is still
> not the same. Could your pass all your examples on RS6000 with hpfcc compiled
> by gcc?
> 
> unparse was not made in the project. Do you make it on RS6000?
> 
> unparse in syr-1.0 can not unparse the dep file generated by hpf2dep in pku-1.1
> correctly.

	Because the dep struct saved on disk is changed , so you'd better
use the readnodes.c or writenodes.c in /src/basicop which i'v updated for 
the new structure .

> 
> Guansong
> 
> ----------------------------------------------
> Hi,
> 
> Glad to know that you also have IBM, this time we can merge our work less
> painful! (Our IBM is runing on AIX 3.2.5, what about yours?)
> 

    Our IBM is RS6000/59H  AIX version 4.

> I have made the pku-1.1 on RS6000, the only directory failed is Vdump. (I think
> the reason is that our machine have defferent version of Motif. Since I met the
> same problem with HIT, I don't check it at the present time.)

   Please give me some information about the errors .

> 
> The hpfcc caused a little problem. I checked the reason. It turned out to be
> that our cc doesn't allow using expression like "a |= b". After changing around
> 10 places in two files (checktype.c and cexpr.c), it can be compiled by both cc
> and gcc on RS/6000.
> 
> The next step, I checked examples under hpfcc/Testsuite, using hpfcc. (Only
> b?.f, g?.f and z?.f, 27 files.)  Here is a breif,
> 
> (z6, z7, z8 can not be parsed by hpf2dep, do we have the same version? They
> also can not be parsed by hpf2dep in syr-1.0.)
 
  These three files is for testing hpf2dep , if you read these test files 
you will certainly find:
  z6.f:
	21: if (i>0)  end 
	              ^^^     illegal statement
  z7.f:
	10: 20      end if
            ^^                This is leagal , but hpf2dep report error !

	other errors are caused by this only error .
  z8.f:
	18: 10 end select
	    ^^                Like z7.f , this is legal , but report error !

> 
> b1, b4, g2, g3, g6, g9, z1, z2, z9 cause memory fault.
> 

 but no memory fault with mine on IBM RS6000/59H . Please debug these files 
using dbx or so , and find where it cause core dump .

The outcome should be : ( on RS6000 )
  b1:
Change LLND at line:16 from 308 to 451.
hpfcc: line 16 error 198:The field 'dd' of record 'aa' is pointer type .
hpfcc: line 16 error 148:Type not match in assignment. 
hpfcc: line 19 error 132:The values in the array constructor must have 
same typ.
___Your HPF program's dep_file have been writen !___

  b4:
hpfcc: line 15 error 557:the 1  actual arg and dummy a :derived type 
mismatched
hpfcc: line 15 error 546:the 2 -th actual argument need dummy keyword
hpfcc: line 15 error 544:non_optional dummy q in subprogram p hasnot been 
assoch
___Your HPF program's dep_file have been writen !___

> when I use gcc to compile hpfcc, the above file also cause memory fault, but
> the we got more semantics error information in the following file:
> 
> b5, g3, z3.
> 
> Do you have the similiar problem on your IBM?

   Nearly all these test files contains this semantics error or that , we
certainly cannot only test files that is semantically correct , this is no 
good to the work .Please read the files and do some changes if neccessary .

> Regards,
> Guansong

    If possible, can you let me access your account and check the problem ?

Regards,

***************************************************************************
*     Zheng Gengbin                 *                                     *
*                                   *                                     *
*  Dept. of Computer Science        *  Phone:  86-10-2585088              *
*         & Technology              *  Email:                             *
*                                   *      [email-masked]   *
*  Peking University P.R.China      *  Mail:                              *
*                                   *      Room 1077 ,Building 47,        *
*                                   *      Peking University, P.R.China   *
***************************************************************************